# improbRunInfo.sql was originally generated by the autoSql program, which also 
# generated improbRunInfo.c and improbRunInfo.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Information on one Improbizer run plus motifs.
CREATE TABLE improbRunInfo (
    name varchar(255) not null,	# Motif name.
    runScore float not null,	# Score of motifFound.
    bestControlScore float not null,	# Score of best control run.
    meanControlScore float not null,	# Mean of control runs.
    sdControlScore float not null,	# Control run standard deviation.
    seqCount int not null,	# Number of sequences used to generate it.
    consensus varchar(255) not null,	# Motif consensus sequence.
    runPos float not null,	# Position of motif in run.
    runPosSd float not null,	# Standard deviation of position in run.
    columnCount int not null,	# Count of columns in motif.
    aProb longblob not null,	# Probability of A's in each column.
    cProb longblob not null,	# Probability of C's in each column.
    gProb longblob not null,	# Probability of G's in each column.
    tProb longblob not null,	# Probability of T's in each column.
    controlCount int not null,	# Count of controls.
    controlScores longblob not null,	# Scores of controls.
              #Indices
    PRIMARY KEY(name)
);
