/* bed5FloatScore.h was originally generated by the autoSql program, which also 
 * generated bed5FloatScore.c and bed5FloatScore.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2005 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef BED5FLOATSCORE_H
#define BED5FLOATSCORE_H

#define BED5FLOATSCORE_NUM_COLS 6

struct bed5FloatScore
/* BED 5 (with 0-1000 score), but also with floating-point score. */
    {
    struct bed5FloatScore *next;  /* Next in singly linked list. */
    char *chrom;	/* Chromosome */
    unsigned chromStart;	/* Start position in chromosome */
    unsigned chromEnd;	/* End position in chromosome */
    char *name;	/* Name of item */
    int score;	/* 0-1000 score for useScore shading */
    float floatScore;	/* Floating point score. */
    };

void bed5FloatScoreStaticLoad(char **row, struct bed5FloatScore *ret);
/* Load a row from bed5FloatScore table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct bed5FloatScore *bed5FloatScoreLoad(char **row);
/* Load a bed5FloatScore from row fetched with select * from bed5FloatScore
 * from database.  Dispose of this with bed5FloatScoreFree(). */

struct bed5FloatScore *bed5FloatScoreLoadAll(char *fileName);
/* Load all bed5FloatScore from whitespace-separated file.
 * Dispose of this with bed5FloatScoreFreeList(). */

struct bed5FloatScore *bed5FloatScoreLoadAllByChar(char *fileName, char chopper);
/* Load all bed5FloatScore from chopper separated file.
 * Dispose of this with bed5FloatScoreFreeList(). */

#define bed5FloatScoreLoadAllByTab(a) bed5FloatScoreLoadAllByChar(a, '\t');
/* Load all bed5FloatScore from tab separated file.
 * Dispose of this with bed5FloatScoreFreeList(). */

struct bed5FloatScore *bed5FloatScoreCommaIn(char **pS, struct bed5FloatScore *ret);
/* Create a bed5FloatScore out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new bed5FloatScore */

void bed5FloatScoreFree(struct bed5FloatScore **pEl);
/* Free a single dynamically allocated bed5FloatScore such as created
 * with bed5FloatScoreLoad(). */

void bed5FloatScoreFreeList(struct bed5FloatScore **pList);
/* Free a list of dynamically allocated bed5FloatScore's */

void bed5FloatScoreOutput(struct bed5FloatScore *el, FILE *f, char sep, char lastSep);
/* Print out bed5FloatScore.  Separate fields with sep. Follow last field with lastSep. */

#define bed5FloatScoreTabOut(el,f) bed5FloatScoreOutput(el,f,'\t','\n');
/* Print out bed5FloatScore as a line in a tab-separated file. */

#define bed5FloatScoreCommaOut(el,f) bed5FloatScoreOutput(el,f,',',',');
/* Print out bed5FloatScore as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* BED5FLOATSCORE_H */

