/* delHinds2.h was originally generated by the autoSql program, which also 
 * generated delHinds2.c and delHinds2.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2007 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef DELHINDS2_H
#define DELHINDS2_H

#define DELHINDS2_NUM_COLS 5

struct delHinds2
/* Deletions from Hinds with frequency */
    {
    struct delHinds2 *next;  /* Next in singly linked list. */
    char *chrom;	/* Reference sequence chromosome or scaffold */
    unsigned chromStart;	/* Start position in chrom */
    unsigned chromEnd;	/* End position in chrom */
    char *name;	/* Name */
    float frequency;	/* Frequency */
    };

void delHinds2StaticLoad(char **row, struct delHinds2 *ret);
/* Load a row from delHinds2 table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct delHinds2 *delHinds2Load(char **row);
/* Load a delHinds2 from row fetched with select * from delHinds2
 * from database.  Dispose of this with delHinds2Free(). */

struct delHinds2 *delHinds2LoadAll(char *fileName);
/* Load all delHinds2 from whitespace-separated file.
 * Dispose of this with delHinds2FreeList(). */

struct delHinds2 *delHinds2LoadAllByChar(char *fileName, char chopper);
/* Load all delHinds2 from chopper separated file.
 * Dispose of this with delHinds2FreeList(). */

#define delHinds2LoadAllByTab(a) delHinds2LoadAllByChar(a, '\t');
/* Load all delHinds2 from tab separated file.
 * Dispose of this with delHinds2FreeList(). */

struct delHinds2 *delHinds2CommaIn(char **pS, struct delHinds2 *ret);
/* Create a delHinds2 out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new delHinds2 */

void delHinds2Free(struct delHinds2 **pEl);
/* Free a single dynamically allocated delHinds2 such as created
 * with delHinds2Load(). */

void delHinds2FreeList(struct delHinds2 **pList);
/* Free a list of dynamically allocated delHinds2's */

void delHinds2Output(struct delHinds2 *el, FILE *f, char sep, char lastSep);
/* Print out delHinds2.  Separate fields with sep. Follow last field with lastSep. */

#define delHinds2TabOut(el,f) delHinds2Output(el,f,'\t','\n');
/* Print out delHinds2 as a line in a tab-separated file. */

#define delHinds2CommaOut(el,f) delHinds2Output(el,f,',',',');
/* Print out delHinds2 as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* DELHINDS2_H */

