/* encodeErgeInVitroFoot.h was originally generated by the autoSql program, which also 
 * generated encodeErgeInVitroFoot.c and encodeErgeInVitroFoot.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2008 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef ENCODEERGEINVITROFOOT_H
#define ENCODEERGEINVITROFOOT_H

#define ENCODEERGEINVITROFOOT_NUM_COLS 14

struct encodeErgeInVitroFoot
/* ENCODE experimental data from dbERGEII */
    {
    struct encodeErgeInVitroFoot *next;  /* Next in singly linked list. */
    char *chrom;	/* Human chromosome */
    unsigned chromStart;	/* Start position in chromosome */
    unsigned chromEnd;	/* End position in chromosome */
    char *name;	/* Name of read - up to 255 characters */
    unsigned score;	/* Score from 0-1000.  1000 is best */
    char strand[2];	/* Value should be + or - */
    unsigned thickStart;	/* Start of where display should be thick (start codon) */
    unsigned thickEnd;	/* End of where display should be thick (stop codon) */
    unsigned reserved;	/* Always zero for now */
    unsigned blockCount;	/* Number of separate blocks (regions without gaps) */
    unsigned *blockSizes;	/* Comma separated list of block sizes */
    unsigned *chromStarts;	/* Start position of each block in relative to chromStart */
    char *Id;	/* dbERGEII Id */
    char *color;	/* RGB color values */
    };

struct encodeErgeInVitroFoot *encodeErgeInVitroFootLoad(char **row);
/* Load a encodeErgeInVitroFoot from row fetched with select * from encodeErgeInVitroFoot
 * from database.  Dispose of this with encodeErgeInVitroFootFree(). */

struct encodeErgeInVitroFoot *encodeErgeInVitroFootLoadAll(char *fileName);
/* Load all encodeErgeInVitroFoot from whitespace-separated file.
 * Dispose of this with encodeErgeInVitroFootFreeList(). */

struct encodeErgeInVitroFoot *encodeErgeInVitroFootLoadAllByChar(char *fileName, char chopper);
/* Load all encodeErgeInVitroFoot from chopper separated file.
 * Dispose of this with encodeErgeInVitroFootFreeList(). */

#define encodeErgeInVitroFootLoadAllByTab(a) encodeErgeInVitroFootLoadAllByChar(a, '\t');
/* Load all encodeErgeInVitroFoot from tab separated file.
 * Dispose of this with encodeErgeInVitroFootFreeList(). */

struct encodeErgeInVitroFoot *encodeErgeInVitroFootCommaIn(char **pS, struct encodeErgeInVitroFoot *ret);
/* Create a encodeErgeInVitroFoot out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new encodeErgeInVitroFoot */

void encodeErgeInVitroFootFree(struct encodeErgeInVitroFoot **pEl);
/* Free a single dynamically allocated encodeErgeInVitroFoot such as created
 * with encodeErgeInVitroFootLoad(). */

void encodeErgeInVitroFootFreeList(struct encodeErgeInVitroFoot **pList);
/* Free a list of dynamically allocated encodeErgeInVitroFoot's */

void encodeErgeInVitroFootOutput(struct encodeErgeInVitroFoot *el, FILE *f, char sep, char lastSep);
/* Print out encodeErgeInVitroFoot.  Separate fields with sep. Follow last field with lastSep. */

#define encodeErgeInVitroFootTabOut(el,f) encodeErgeInVitroFootOutput(el,f,'\t','\n');
/* Print out encodeErgeInVitroFoot as a line in a tab-separated file. */

#define encodeErgeInVitroFootCommaOut(el,f) encodeErgeInVitroFootOutput(el,f,',',',');
/* Print out encodeErgeInVitroFoot as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* ENCODEERGEINVITROFOOT_H */

