/* wgEncodeGencodeExonSupport.h was originally generated by the autoSql program, which also 
 * generated wgEncodeGencodeExonSupport.c and wgEncodeGencodeExonSupport.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2012 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef WGENCODEGENCODEEXONSUPPORT_H
#define WGENCODEGENCODEEXONSUPPORT_H

#define WGENCODEGENCODEEXONSUPPORT_NUM_COLS 7

struct wgEncodeGencodeExonSupport
/* GENCODE exon support from other datasets */
    {
    struct wgEncodeGencodeExonSupport *next;  /* Next in singly linked list. */
    char *transcriptId;	/* GENCODE transcript identifier */
    char *seqId;	/* Identifier of sequence supporting transcript */
    char *seqSrc;	/* Source of supporting sequence */
    char *exonId;	/* GENCODE exon identifier (not stable) */
    char *chrom;	/* Chromosome */
    unsigned chromStart;	/* Start position in chromosome */
    unsigned chromEnd;	/* End position in chromosome */
    };

void wgEncodeGencodeExonSupportStaticLoad(char **row, struct wgEncodeGencodeExonSupport *ret);
/* Load a row from wgEncodeGencodeExonSupport table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct wgEncodeGencodeExonSupport *wgEncodeGencodeExonSupportLoad(char **row);
/* Load a wgEncodeGencodeExonSupport from row fetched with select * from wgEncodeGencodeExonSupport
 * from database.  Dispose of this with wgEncodeGencodeExonSupportFree(). */

struct wgEncodeGencodeExonSupport *wgEncodeGencodeExonSupportLoadAll(char *fileName);
/* Load all wgEncodeGencodeExonSupport from whitespace-separated file.
 * Dispose of this with wgEncodeGencodeExonSupportFreeList(). */

struct wgEncodeGencodeExonSupport *wgEncodeGencodeExonSupportLoadAllByChar(char *fileName, char chopper);
/* Load all wgEncodeGencodeExonSupport from chopper separated file.
 * Dispose of this with wgEncodeGencodeExonSupportFreeList(). */

#define wgEncodeGencodeExonSupportLoadAllByTab(a) wgEncodeGencodeExonSupportLoadAllByChar(a, '\t');
/* Load all wgEncodeGencodeExonSupport from tab separated file.
 * Dispose of this with wgEncodeGencodeExonSupportFreeList(). */

struct wgEncodeGencodeExonSupport *wgEncodeGencodeExonSupportCommaIn(char **pS, struct wgEncodeGencodeExonSupport *ret);
/* Create a wgEncodeGencodeExonSupport out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new wgEncodeGencodeExonSupport */

void wgEncodeGencodeExonSupportFree(struct wgEncodeGencodeExonSupport **pEl);
/* Free a single dynamically allocated wgEncodeGencodeExonSupport such as created
 * with wgEncodeGencodeExonSupportLoad(). */

void wgEncodeGencodeExonSupportFreeList(struct wgEncodeGencodeExonSupport **pList);
/* Free a list of dynamically allocated wgEncodeGencodeExonSupport's */

void wgEncodeGencodeExonSupportOutput(struct wgEncodeGencodeExonSupport *el, FILE *f, char sep, char lastSep);
/* Print out wgEncodeGencodeExonSupport.  Separate fields with sep. Follow last field with lastSep. */

#define wgEncodeGencodeExonSupportTabOut(el,f) wgEncodeGencodeExonSupportOutput(el,f,'\t','\n');
/* Print out wgEncodeGencodeExonSupport as a line in a tab-separated file. */

#define wgEncodeGencodeExonSupportCommaOut(el,f) wgEncodeGencodeExonSupportOutput(el,f,',',',');
/* Print out wgEncodeGencodeExonSupport as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* WGENCODEGENCODEEXONSUPPORT_H */

