/* wgEncodeGencodeTranscriptionSupportLevel.h was originally generated by the autoSql program, which also 
 * generated wgEncodeGencodeTranscriptionSupportLevel.c and wgEncodeGencodeTranscriptionSupportLevel.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2012 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef WGENCODEGENCODETRANSCRIPTIONSUPPORTLEVEL_H
#define WGENCODEGENCODETRANSCRIPTIONSUPPORTLEVEL_H

#define WGENCODEGENCODETRANSCRIPTIONSUPPORTLEVEL_NUM_COLS 2

struct wgEncodeGencodeTranscriptionSupportLevel
/* GENCODE transcription support level, computed from primary data */
    {
    struct wgEncodeGencodeTranscriptionSupportLevel *next;  /* Next in singly linked list. */
    char *transcriptId;	/* GENCODE transcript identifier */
    int level;	/* support level, 1 is strongest support, 5 weakest, -1 means not analyzed */
    };

void wgEncodeGencodeTranscriptionSupportLevelStaticLoad(char **row, struct wgEncodeGencodeTranscriptionSupportLevel *ret);
/* Load a row from wgEncodeGencodeTranscriptionSupportLevel table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct wgEncodeGencodeTranscriptionSupportLevel *wgEncodeGencodeTranscriptionSupportLevelLoad(char **row);
/* Load a wgEncodeGencodeTranscriptionSupportLevel from row fetched with select * from wgEncodeGencodeTranscriptionSupportLevel
 * from database.  Dispose of this with wgEncodeGencodeTranscriptionSupportLevelFree(). */

struct wgEncodeGencodeTranscriptionSupportLevel *wgEncodeGencodeTranscriptionSupportLevelLoadAll(char *fileName);
/* Load all wgEncodeGencodeTranscriptionSupportLevel from whitespace-separated file.
 * Dispose of this with wgEncodeGencodeTranscriptionSupportLevelFreeList(). */

struct wgEncodeGencodeTranscriptionSupportLevel *wgEncodeGencodeTranscriptionSupportLevelLoadAllByChar(char *fileName, char chopper);
/* Load all wgEncodeGencodeTranscriptionSupportLevel from chopper separated file.
 * Dispose of this with wgEncodeGencodeTranscriptionSupportLevelFreeList(). */

#define wgEncodeGencodeTranscriptionSupportLevelLoadAllByTab(a) wgEncodeGencodeTranscriptionSupportLevelLoadAllByChar(a, '\t');
/* Load all wgEncodeGencodeTranscriptionSupportLevel from tab separated file.
 * Dispose of this with wgEncodeGencodeTranscriptionSupportLevelFreeList(). */

struct wgEncodeGencodeTranscriptionSupportLevel *wgEncodeGencodeTranscriptionSupportLevelCommaIn(char **pS, struct wgEncodeGencodeTranscriptionSupportLevel *ret);
/* Create a wgEncodeGencodeTranscriptionSupportLevel out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new wgEncodeGencodeTranscriptionSupportLevel */

void wgEncodeGencodeTranscriptionSupportLevelFree(struct wgEncodeGencodeTranscriptionSupportLevel **pEl);
/* Free a single dynamically allocated wgEncodeGencodeTranscriptionSupportLevel such as created
 * with wgEncodeGencodeTranscriptionSupportLevelLoad(). */

void wgEncodeGencodeTranscriptionSupportLevelFreeList(struct wgEncodeGencodeTranscriptionSupportLevel **pList);
/* Free a list of dynamically allocated wgEncodeGencodeTranscriptionSupportLevel's */

void wgEncodeGencodeTranscriptionSupportLevelOutput(struct wgEncodeGencodeTranscriptionSupportLevel *el, FILE *f, char sep, char lastSep);
/* Print out wgEncodeGencodeTranscriptionSupportLevel.  Separate fields with sep. Follow last field with lastSep. */

#define wgEncodeGencodeTranscriptionSupportLevelTabOut(el,f) wgEncodeGencodeTranscriptionSupportLevelOutput(el,f,'\t','\n');
/* Print out wgEncodeGencodeTranscriptionSupportLevel as a line in a tab-separated file. */

#define wgEncodeGencodeTranscriptionSupportLevelCommaOut(el,f) wgEncodeGencodeTranscriptionSupportLevelOutput(el,f,',',',');
/* Print out wgEncodeGencodeTranscriptionSupportLevel as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* WGENCODEGENCODETRANSCRIPTIONSUPPORTLEVEL_H */

