/* gtexTissueMedian.h was originally generated by the autoSql program, which also 
 * generated gtexTissueMedian.c and gtexTissueMedian.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef GTEXTISSUEMEDIAN_H
#define GTEXTISSUEMEDIAN_H

#define GTEXTISSUEMEDIAN_NUM_COLS 3

extern char *gtexTissueMedianCommaSepFieldNames;

struct gtexTissueMedian
/* GTEX Expression median level by tissue (RPKM levels, unmapped) */
    {
    struct gtexTissueMedian *next;  /* Next in singly linked list. */
    char *geneId;	/* Gene identifier (ensembl) */
    unsigned tissueCount;	/* Number of tissues */
    float *scores;	/* RPKM median expression levels */
    };

struct gtexTissueMedian *gtexTissueMedianLoad(char **row);
/* Load a gtexTissueMedian from row fetched with select * from gtexTissueMedian
 * from database.  Dispose of this with gtexTissueMedianFree(). */

struct gtexTissueMedian *gtexTissueMedianLoadAll(char *fileName);
/* Load all gtexTissueMedian from whitespace-separated file.
 * Dispose of this with gtexTissueMedianFreeList(). */

struct gtexTissueMedian *gtexTissueMedianLoadAllByChar(char *fileName, char chopper);
/* Load all gtexTissueMedian from chopper separated file.
 * Dispose of this with gtexTissueMedianFreeList(). */

#define gtexTissueMedianLoadAllByTab(a) gtexTissueMedianLoadAllByChar(a, '\t');
/* Load all gtexTissueMedian from tab separated file.
 * Dispose of this with gtexTissueMedianFreeList(). */

struct gtexTissueMedian *gtexTissueMedianCommaIn(char **pS, struct gtexTissueMedian *ret);
/* Create a gtexTissueMedian out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new gtexTissueMedian */

void gtexTissueMedianFree(struct gtexTissueMedian **pEl);
/* Free a single dynamically allocated gtexTissueMedian such as created
 * with gtexTissueMedianLoad(). */

void gtexTissueMedianFreeList(struct gtexTissueMedian **pList);
/* Free a list of dynamically allocated gtexTissueMedian's */

void gtexTissueMedianOutput(struct gtexTissueMedian *el, FILE *f, char sep, char lastSep);
/* Print out gtexTissueMedian.  Separate fields with sep. Follow last field with lastSep. */

#define gtexTissueMedianTabOut(el,f) gtexTissueMedianOutput(el,f,'\t','\n');
/* Print out gtexTissueMedian as a line in a tab-separated file. */

#define gtexTissueMedianCommaOut(el,f) gtexTissueMedianOutput(el,f,',',',');
/* Print out gtexTissueMedian as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

void gtexTissueMedianCreateTable(struct sqlConnection *conn, char *table);
/* Create expression record format table of given name. */

#endif /* GTEXTISSUEMEDIAN_H */

