/* lowelabTIGROperonScore.h was originally generated by the autoSql program, which also 
 * generated lowelabTIGROperonScore.c and lowelabTIGROperonScore.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2007 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef LOWELABTIGROPERONSCORE_H
#define LOWELABTIGROPERONSCORE_H

#define LOWELABTIGROPERONSCORE_NUM_COLS 6

struct lowelabTIGROperonScore
/* TIGR operon score */
    {
    struct lowelabTIGROperonScore *next;  /* Next in singly linked list. */
    char *name;	/* operon name */
    char *gene1;	/* name of gene1 */
    char *gene2;	/* name of gene2 */
    int confidence;	/* confidence level of operon */
    int ortholog;	/* number of orthologous genes */
    char *ortholog_link;	/* url on operondb */
    };

void lowelabTIGROperonScoreStaticLoad(char **row, struct lowelabTIGROperonScore *ret);
/* Load a row from lowelabTIGROperonScore table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct lowelabTIGROperonScore *lowelabTIGROperonScoreLoad(char **row);
/* Load a lowelabTIGROperonScore from row fetched with select * from lowelabTIGROperonScore
 * from database.  Dispose of this with lowelabTIGROperonScoreFree(). */

struct lowelabTIGROperonScore *lowelabTIGROperonScoreLoadAll(char *fileName);
/* Load all lowelabTIGROperonScore from whitespace-separated file.
 * Dispose of this with lowelabTIGROperonScoreFreeList(). */

struct lowelabTIGROperonScore *lowelabTIGROperonScoreLoadAllByChar(char *fileName, char chopper);
/* Load all lowelabTIGROperonScore from chopper separated file.
 * Dispose of this with lowelabTIGROperonScoreFreeList(). */

#define lowelabTIGROperonScoreLoadAllByTab(a) lowelabTIGROperonScoreLoadAllByChar(a, '\t');
/* Load all lowelabTIGROperonScore from tab separated file.
 * Dispose of this with lowelabTIGROperonScoreFreeList(). */

struct lowelabTIGROperonScore *lowelabTIGROperonScoreCommaIn(char **pS, struct lowelabTIGROperonScore *ret);
/* Create a lowelabTIGROperonScore out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new lowelabTIGROperonScore */

void lowelabTIGROperonScoreFree(struct lowelabTIGROperonScore **pEl);
/* Free a single dynamically allocated lowelabTIGROperonScore such as created
 * with lowelabTIGROperonScoreLoad(). */

void lowelabTIGROperonScoreFreeList(struct lowelabTIGROperonScore **pList);
/* Free a list of dynamically allocated lowelabTIGROperonScore's */

void lowelabTIGROperonScoreOutput(struct lowelabTIGROperonScore *el, FILE *f, char sep, char lastSep);
/* Print out lowelabTIGROperonScore.  Separate fields with sep. Follow last field with lastSep. */

#define lowelabTIGROperonScoreTabOut(el,f) lowelabTIGROperonScoreOutput(el,f,'\t','\n');
/* Print out lowelabTIGROperonScore as a line in a tab-separated file. */

#define lowelabTIGROperonScoreCommaOut(el,f) lowelabTIGROperonScoreOutput(el,f,',',',');
/* Print out lowelabTIGROperonScore as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* LOWELABTIGROPERONSCORE_H */

