/* pairedTagAlign.h was originally generated by the autoSql program, which also 
 * generated pairedTagAlign.c and pairedTagAlign.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2008 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef PAIREDTAGALIGN_H
#define PAIREDTAGALIGN_H

#define PAIREDTAGALIGN_NUM_COLS 8

struct pairedTagAlign
/* Peaks format (BED 6+) */
    {
    struct pairedTagAlign *next;  /* Next in singly linked list. */
    char *chrom;	/* Reference sequence chromosome or scaffold */
    unsigned chromStart;	/* Start position in chromosome */
    unsigned chromEnd;	/* End position in chromosome */
    char *name;	/* Name of item */
    unsigned score;	/* Score from 0-1000 */
    char strand[2];	/* + or - */
    char *seq1;	/* Sequence of first read */
    char *seq2;	/* Sequence of second read */
    };

void pairedTagAlignStaticLoad(char **row, struct pairedTagAlign *ret);
/* Load a row from pairedTagAlign table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct pairedTagAlign *pairedTagAlignLoad(char **row);
/* Load a pairedTagAlign from row fetched with select * from pairedTagAlign
 * from database.  Dispose of this with pairedTagAlignFree(). */

struct pairedTagAlign *pairedTagAlignLoadAll(char *fileName);
/* Load all pairedTagAlign from whitespace-separated file.
 * Dispose of this with pairedTagAlignFreeList(). */

struct pairedTagAlign *pairedTagAlignLoadAllByChar(char *fileName, char chopper);
/* Load all pairedTagAlign from chopper separated file.
 * Dispose of this with pairedTagAlignFreeList(). */

#define pairedTagAlignLoadAllByTab(a) pairedTagAlignLoadAllByChar(a, '\t');
/* Load all pairedTagAlign from tab separated file.
 * Dispose of this with pairedTagAlignFreeList(). */

struct pairedTagAlign *pairedTagAlignCommaIn(char **pS, struct pairedTagAlign *ret);
/* Create a pairedTagAlign out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new pairedTagAlign */

void pairedTagAlignFree(struct pairedTagAlign **pEl);
/* Free a single dynamically allocated pairedTagAlign such as created
 * with pairedTagAlignLoad(). */

void pairedTagAlignFreeList(struct pairedTagAlign **pList);
/* Free a list of dynamically allocated pairedTagAlign's */

void pairedTagAlignOutput(struct pairedTagAlign *el, FILE *f, char sep, char lastSep);
/* Print out pairedTagAlign.  Separate fields with sep. Follow last field with lastSep. */

#define pairedTagAlignTabOut(el,f) pairedTagAlignOutput(el,f,'\t','\n');
/* Print out pairedTagAlign as a line in a tab-separated file. */

#define pairedTagAlignCommaOut(el,f) pairedTagAlignOutput(el,f,',',',');
/* Print out pairedTagAlign as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* PAIREDTAGALIGN_H */

