/* sargassoSeaXra.h was originally generated by the autoSql program, which also 
 * generated sargassoSeaXra.c and sargassoSeaXra.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2004 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef SARGASSOSEAXRA_H
#define SARGASSOSEAXRA_H

#define SARGASSOSEAXRA_NUM_COLS 13

struct sargassoSeaXra
/* Table storing the codes and positional info for blast runs. */
    {
    struct sargassoSeaXra *next;  /* Next in singly linked list. */
    char *qName;	/* Name of item */
    char code[2];	/* Code */
    char *evalue;	/* evalue */
    unsigned GI;	/* GI Number */
    float PI;	/* Percent Identity */
    unsigned length;	/* Alignment length */
    unsigned gap;	/* gap length */
    unsigned score;	/* score from evalue */
    unsigned queryseqstart;	/* Where alignment begins */
    unsigned queryseqend;	/* Where alignment ends */
    char species[256];	/* Code */
    unsigned thisseqstart;	/* Where alignment in sSea begins */
    unsigned thisseqend;	/* Where alignment in sSea ends */
    };

void sargassoSeaXraStaticLoad(char **row, struct sargassoSeaXra *ret);
/* Load a row from sargassoSeaXra table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct sargassoSeaXra *sargassoSeaXraLoad(char **row);
/* Load a sargassoSeaXra from row fetched with select * from sargassoSeaXra
 * from database.  Dispose of this with sargassoSeaXraFree(). */

struct sargassoSeaXra *sargassoSeaXraLoadAll(char *fileName);
/* Load all sargassoSeaXra from whitespace-separated file.
 * Dispose of this with sargassoSeaXraFreeList(). */

struct sargassoSeaXra *sargassoSeaXraLoadAllByChar(char *fileName, char chopper);
/* Load all sargassoSeaXra from chopper separated file.
 * Dispose of this with sargassoSeaXraFreeList(). */

#define sargassoSeaXraLoadAllByTab(a) sargassoSeaXraLoadAllByChar(a, '\t');
/* Load all sargassoSeaXra from tab separated file.
 * Dispose of this with sargassoSeaXraFreeList(). */

struct sargassoSeaXra *sargassoSeaXraCommaIn(char **pS, struct sargassoSeaXra *ret);
/* Create a sargassoSeaXra out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new sargassoSeaXra */

void sargassoSeaXraFree(struct sargassoSeaXra **pEl);
/* Free a single dynamically allocated sargassoSeaXra such as created
 * with sargassoSeaXraLoad(). */

void sargassoSeaXraFreeList(struct sargassoSeaXra **pList);
/* Free a list of dynamically allocated sargassoSeaXra's */

void sargassoSeaXraOutput(struct sargassoSeaXra *el, FILE *f, char sep, char lastSep);
/* Print out sargassoSeaXra.  Separate fields with sep. Follow last field with lastSep. */

#define sargassoSeaXraTabOut(el,f) sargassoSeaXraOutput(el,f,'\t','\n');
/* Print out sargassoSeaXra as a line in a tab-separated file. */

#define sargassoSeaXraCommaOut(el,f) sargassoSeaXraOutput(el,f,',',',');
/* Print out sargassoSeaXra as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* SARGASSOSEAXRA_H */

