/* yaleGencodeAssoc.h was originally generated by the autoSql program, which also 
 * generated yaleGencodeAssoc.c and yaleGencodeAssoc.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2010 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef YALEGENCODEASSOC_H
#define YALEGENCODEASSOC_H

#define YALESANGERASSOC_NUM_COLS 3

struct yaleGencodeAssoc
/* association of Yale pseudogenes with Gencode transcripts */
    {
    struct yaleGencodeAssoc *next;  /* Next in singly linked list. */
    char *transcript;	/* Gencode transcript id */
    char *yaleId;	/* Yale id */
    char *locus;	/* Gencode locus id */
    };

void yaleGencodeAssocStaticLoad(char **row, struct yaleGencodeAssoc *ret);
/* Load a row from yaleGencodeAssoc table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct yaleGencodeAssoc *yaleGencodeAssocLoad(char **row);
/* Load a yaleGencodeAssoc from row fetched with select * from yaleGencodeAssoc
 * from database.  Dispose of this with yaleGencodeAssocFree(). */

struct yaleGencodeAssoc *yaleGencodeAssocLoadAll(char *fileName);
/* Load all yaleGencodeAssoc from whitespace-separated file.
 * Dispose of this with yaleGencodeAssocFreeList(). */

struct yaleGencodeAssoc *yaleGencodeAssocLoadAllByChar(char *fileName, char chopper);
/* Load all yaleGencodeAssoc from chopper separated file.
 * Dispose of this with yaleGencodeAssocFreeList(). */

#define yaleGencodeAssocLoadAllByTab(a) yaleGencodeAssocLoadAllByChar(a, '\t');
/* Load all yaleGencodeAssoc from tab separated file.
 * Dispose of this with yaleGencodeAssocFreeList(). */

struct yaleGencodeAssoc *yaleGencodeAssocCommaIn(char **pS, struct yaleGencodeAssoc *ret);
/* Create a yaleGencodeAssoc out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new yaleGencodeAssoc */

void yaleGencodeAssocFree(struct yaleGencodeAssoc **pEl);
/* Free a single dynamically allocated yaleGencodeAssoc such as created
 * with yaleGencodeAssocLoad(). */

void yaleGencodeAssocFreeList(struct yaleGencodeAssoc **pList);
/* Free a list of dynamically allocated yaleGencodeAssoc's */

void yaleGencodeAssocOutput(struct yaleGencodeAssoc *el, FILE *f, char sep, char lastSep);
/* Print out yaleGencodeAssoc.  Separate fields with sep. Follow last field with lastSep. */

#define yaleGencodeAssocTabOut(el,f) yaleGencodeAssocOutput(el,f,'\t','\n');
/* Print out yaleGencodeAssoc as a line in a tab-separated file. */

#define yaleGencodeAssocCommaOut(el,f) yaleGencodeAssocOutput(el,f,',',',');
/* Print out yaleGencodeAssoc as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* YALEGENCODEASSOC_H */

