# affy120KDetails.sql was originally generated by the autoSql program, which also 
# generated affy120KDetails.c and affy120KDetails.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Information from affyGenoDetails representing the Affymetrix 120K SNP Genotyping array
CREATE TABLE affy120KDetails (
    affyId 	int 			not null,	# Affymetrix SNP id
    rsId 	varchar(255) 		not null,	# RS identifier
    baseA 	enum('X', 'A','C','G') 	default 'X',	# The first allele (A)
    baseB 	enum('X', 'C','G','T') 	default 'X',	# The second allele (B)
    sequenceA 	char(34) 		not null,	# The A allele with flanking sequence
    sequenceB 	char(34) 		not null,	# The B allele with flanking sequence
    enzyme  	enum('X', 'HindIII','XbaI') default 'X',# The enzyme that was used to prepare the sample (HindIII or XbaI)
    minFreq 	float 			not null,	# The minimum allele frequency
    hetzyg  	float 			not null,	# The heterozygosity from all observations
    avHetSE 	float 			not null,	# The Standard Error for the average heterozygosity (not used)
    NA04477 	char(2) not null,	# Individual 01
    NA04479 	char(2) not null,	# Individual 02
    NA04846 	char(2) not null,	# Individual 03
    NA11036 	char(2) not null,	# Individual 04
    NA11038 	char(2) not null,	# Individual 05
    NA13056 	char(2) not null,	# Individual 06
    NA17011 	char(2) not null,	# Individual 07
    NA17012 	char(2) not null,	# Individual 08
    NA17013 	char(2) not null,	# Individual 09
    NA17014 	char(2) not null,	# Individual 10
    NA17015 	char(2) not null,	# Individual 11
    NA17016 	char(2) not null,	# Individual 12
    NA17101 	char(2) not null,	# Individual 13
    NA17102 	char(2) not null,	# Individual 14
    NA17103 	char(2) not null,	# Individual 15
    NA17104 	char(2) not null,	# Individual 16
    NA17105 	char(2) not null,	# Individual 17
    NA17106 	char(2) not null,	# Individual 18
    NA17201 	char(2) not null,	# Individual 19
    NA17202 	char(2) not null,	# Individual 20
    NA17203 	char(2) not null,	# Individual 21
    NA17204 	char(2) not null,	# Individual 22
    NA17205 	char(2) not null,	# Individual 23
    NA17206 	char(2) not null,	# Individual 24
    NA17207 	char(2) not null,	# Individual 25
    NA17208 	char(2) not null,	# Individual 26
    NA17210 	char(2) not null,	# Individual 27
    NA17211 	char(2) not null,	# Individual 28
    NA17212 	char(2) not null,	# Individual 29
    NA17213 	char(2) not null,	# Individual 30
    PD01 	char(2) not null,	# Individual 31
    PD02 	char(2) not null,	# Individual 32
    PD03 	char(2) not null,	# Individual 33
    PD04 	char(2) not null,	# Individual 34
    PD05 	char(2) not null,	# Individual 35
    PD06 	char(2) not null,	# Individual 36
    PD07 	char(2) not null,	# Individual 37
    PD08 	char(2) not null,	# Individual 38
    PD09 	char(2) not null,	# Individual 39
    PD10 	char(2) not null,	# Individual 40
    PD11 	char(2) not null,	# Individual 41
    PD12 	char(2) not null,	# Individual 42
    PD13 	char(2) not null,	# Individual 43
    PD14 	char(2) not null,	# Individual 44
    PD15 	char(2) not null,	# Individual 45
    PD16 	char(2) not null,	# Individual 46
    PD17 	char(2) not null,	# Individual 47
    PD18 	char(2) not null,	# Individual 48
    PD19 	char(2) not null,	# Individual 49
    PD20 	char(2) not null,	# Individual 50
    PD21 	char(2) not null,	# Individual 51
    PD22 	char(2) not null,	# Individual 52
    PD23 	char(2) not null,	# Individual 53
    PD24 	char(2) not null,	# Individual 54
              #Indices
    PRIMARY KEY(affyId)
);
