# bacCloneXRef.sql was originally generated by the autoSql program, which also 
# generated bacCloneXRef.c and bacCloneXRef.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#BAC clones and corresponding STS information
CREATE TABLE bacCloneXRef (
    name varchar(255),	# External name for BAC clone
    intName varchar(255),	# Internal Sanger FPC name
    chroms varchar(255),	# Chromosome(s) to which at one or both BAC ends are mapped by BLAT
    genbank varchar(255),	# Genbank accession for the BAC Clone
    sangerName varchar(255),	# Sanger STS name
    relationship int unsigned not null,	# Relationship type - method of finding STS
    uniStsId varchar(255),	# UniSTS ID(s) for STS
    leftPrimer varchar(255),	# STS 5' primer sequence
    rightPrimer varchar(255),	# STS 3' primer sequence
              #Indices
    INDEX(name),
    INDEX(intName),
    INDEX(sangerName)
);
