# bdgpExprLink.sql was originally generated by the autoSql program, which also 
# generated bdgpExprLink.c and bdgpExprLink.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Summary info for linking to the BDGP Expression In Situ Images site
CREATE TABLE bdgpExprLink (
    symbol varchar(255) not null,	# Symbolic gene name
    bdgpName varchar(255) not null,	# BDGP gene ID
    flyBaseId varchar(255) not null,	# FlyBase gene ID
    est varchar(255) not null,	# EST accession
    imageCount int not null,	# Number of images for this gene
    bodyPartCount int not null,	# Number of body parts
    plate varchar(255) not null,	# DGC Plate
    platePos int not null,	# Position on plate
    newRelease char(1) not null,	# 'Y' if this gene is a new release
              #Indices
    INDEX(bdgpName(10)), INDEX(flyBaseId(12))
);
