# bdgpSwissProt.sql was originally generated by the autoSql program, which also 
# generated bdgpSwissProt.c and bdgpSwissProt.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Berkeley Drosophile Genome Project Protein-Coding Genes track additional information plus SwissProt acc & desc
CREATE TABLE bdgpSwissProt (
    bdgpName varchar(255) not null,	# BDGP annotation gene name
    flyBaseId varchar(255) not null,	# FlyBase FBgn ID
    go longblob not null,	# comma-sep list of GO numeric IDs
    symbol varchar(255) not null,	# symbolic gene name
    cytorange varchar(255) not null,	# cytorange
    swissProtId varchar(255) not null,	# SwissProt ID
    spGeneName varchar(255) not null,	# (long) gene name from SwissProt
    spSymbol varchar(255) not null,	# symbolic-looking gene id from SwissProt
              #Indices
    INDEX(bdgpName(12)),
    INDEX(flyBaseId(12)),
    INDEX(swissProtId(12))
);
