# bed8Attrs.sql was originally generated by the autoSql program, which also 
# generated bed8Attrs.c and bed8Attrs.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Items with thin (outer) and/or thick (inner) regions and an arbitrary set of attributes
CREATE TABLE bed8Attrs (
    bin smallint not null,      # Bin number for browser speedup
    chrom varchar(255) not null,	# Reference sequence chromosome or scaffold
    chromStart int unsigned not null,	# Start position in chromosome
    chromEnd int unsigned not null,	# End position in chromosome
    name varchar(255) not null,	# Name of item
    score int unsigned not null,	# Score from 0-1000 (might not be applicable)
    strand char(1) not null,	# +, - or . for unknown
    thickStart int unsigned not null,	# Start of where display should be thick
    thickEnd int unsigned not null,	# End of where display should be thick
    attrCount int not null,	# Number of attributes
    attrTags longblob not null,	# Attribute tags/keys
    attrVals longblob not null,	# Attribute values
              #Indices
    INDEX(chrom(8),bin),
    INDEX(name(20))
);
