/* clusterInputAwgDnase.h was originally generated by the autoSql program, which also 
 * generated clusterInputAwgDnase.c and clusterInputAwgDnase.sql.  This header links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2013 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#ifndef CLUSTERINPUTAWGDNASE_H
#define CLUSTERINPUTAWGDNASE_H

#define CLUSTERINPUTAWGDNASE_NUM_COLS 4

struct clusterInputAwgDnase
/* Information on ENCODE analysis (AWG) data used as input for DNase clustering */
    {
    struct clusterInputAwgDnase *next;  /* Next in singly linked list. */
    char *tableName;	/* Name of table used as an input */
    char *cellType;	/* Name of cell type */
    char *treatment;	/* Drug or other treatment given to cells while alive */
    char *lab;	/* Lab this was done in */
    };

void clusterInputAwgDnaseStaticLoad(char **row, struct clusterInputAwgDnase *ret);
/* Load a row from clusterInputAwgDnase table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct clusterInputAwgDnase *clusterInputAwgDnaseLoad(char **row);
/* Load a clusterInputAwgDnase from row fetched with select * from clusterInputAwgDnase
 * from database.  Dispose of this with clusterInputAwgDnaseFree(). */

struct clusterInputAwgDnase *clusterInputAwgDnaseLoadAll(char *fileName);
/* Load all clusterInputAwgDnase from whitespace-separated file.
 * Dispose of this with clusterInputAwgDnaseFreeList(). */

struct clusterInputAwgDnase *clusterInputAwgDnaseLoadAllByChar(char *fileName, char chopper);
/* Load all clusterInputAwgDnase from chopper separated file.
 * Dispose of this with clusterInputAwgDnaseFreeList(). */

#define clusterInputAwgDnaseLoadAllByTab(a) clusterInputAwgDnaseLoadAllByChar(a, '\t');
/* Load all clusterInputAwgDnase from tab separated file.
 * Dispose of this with clusterInputAwgDnaseFreeList(). */

struct clusterInputAwgDnase *clusterInputAwgDnaseCommaIn(char **pS, struct clusterInputAwgDnase *ret);
/* Create a clusterInputAwgDnase out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new clusterInputAwgDnase */

void clusterInputAwgDnaseFree(struct clusterInputAwgDnase **pEl);
/* Free a single dynamically allocated clusterInputAwgDnase such as created
 * with clusterInputAwgDnaseLoad(). */

void clusterInputAwgDnaseFreeList(struct clusterInputAwgDnase **pList);
/* Free a list of dynamically allocated clusterInputAwgDnase's */

void clusterInputAwgDnaseOutput(struct clusterInputAwgDnase *el, FILE *f, char sep, char lastSep);
/* Print out clusterInputAwgDnase.  Separate fields with sep. Follow last field with lastSep. */

#define clusterInputAwgDnaseTabOut(el,f) clusterInputAwgDnaseOutput(el,f,'\t','\n');
/* Print out clusterInputAwgDnase as a line in a tab-separated file. */

#define clusterInputAwgDnaseCommaOut(el,f) clusterInputAwgDnaseOutput(el,f,',',',');
/* Print out clusterInputAwgDnase as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* CLUSTERINPUTAWGDNASE_H */

