# cnpSharp.sql was originally generated by the autoSql program, which also 
# generated cnpSharp.c and cnpSharp.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#CNP data from Sharp lab
CREATE TABLE cnpSharp (
    bin smallint int null,		# For speed
    chrom varchar(255) not null,	# Chromosome
    chromStart int unsigned not null,	# Start position in chrom
    chromEnd int unsigned not null,	# End position in chrom
    name varchar(255) not null,		# BAC name
    variationType enum('Gain', 'Loss', 'Gain and Loss') not null,	# Gain, Loss, Gain and Loss
    cytoName varchar(255) not null,	# Cytoband
    cytoStrain varchar(255) not null,	# gneg, gpos, etc.
    dupPercent float not null,	# 0 to 1
    repeatsPercent float not null,	# 0 to 1
    LINEpercent float not null,	# 0 to 1
    SINEpercent float not null,	# 0 to 1
    LTRpercent float not null,	# 0 to 1
    DNApercent float not null,	# 0 to 1
    diseaseSpotsPercent float not null,	# 0 to 1
    #Indices
    INDEX (chrom(5),bin),
    INDEX (name(12))
);
