/* encodeStanfordPromotersAverage.c was originally generated by the autoSql program, which also 
 * generated encodeStanfordPromotersAverage.h and encodeStanfordPromotersAverage.sql.  This module links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2011 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "encode/encodeStanfordPromotersAverage.h"


void encodeStanfordPromotersAverageStaticLoad(char **row, struct encodeStanfordPromotersAverage *ret)
/* Load a row from encodeStanfordPromotersAverage table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->chrom = row[0];
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = row[3];
ret->score = sqlUnsigned(row[4]);
strcpy(ret->strand, row[5]);
ret->thickStart = sqlUnsigned(row[6]);
ret->thickEnd = sqlUnsigned(row[7]);
ret->reserved = sqlUnsigned(row[8]);
ret->geneModel = row[9];
ret->description = row[10];
ret->normLog2Ratio = atof(row[11]);
}

struct encodeStanfordPromotersAverage *encodeStanfordPromotersAverageLoad(char **row)
/* Load a encodeStanfordPromotersAverage from row fetched with select * from encodeStanfordPromotersAverage
 * from database.  Dispose of this with encodeStanfordPromotersAverageFree(). */
{
struct encodeStanfordPromotersAverage *ret;

AllocVar(ret);
ret->chrom = cloneString(row[0]);
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = cloneString(row[3]);
ret->score = sqlUnsigned(row[4]);
strcpy(ret->strand, row[5]);
ret->thickStart = sqlUnsigned(row[6]);
ret->thickEnd = sqlUnsigned(row[7]);
ret->reserved = sqlUnsigned(row[8]);
ret->geneModel = cloneString(row[9]);
ret->description = cloneString(row[10]);
ret->normLog2Ratio = atof(row[11]);
return ret;
}

struct encodeStanfordPromotersAverage *encodeStanfordPromotersAverageLoadAll(char *fileName) 
/* Load all encodeStanfordPromotersAverage from a whitespace-separated file.
 * Dispose of this with encodeStanfordPromotersAverageFreeList(). */
{
struct encodeStanfordPromotersAverage *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[12];

while (lineFileRow(lf, row))
    {
    el = encodeStanfordPromotersAverageLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct encodeStanfordPromotersAverage *encodeStanfordPromotersAverageLoadAllByChar(char *fileName, char chopper) 
/* Load all encodeStanfordPromotersAverage from a chopper separated file.
 * Dispose of this with encodeStanfordPromotersAverageFreeList(). */
{
struct encodeStanfordPromotersAverage *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[12];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = encodeStanfordPromotersAverageLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct encodeStanfordPromotersAverage *encodeStanfordPromotersAverageCommaIn(char **pS, struct encodeStanfordPromotersAverage *ret)
/* Create a encodeStanfordPromotersAverage out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new encodeStanfordPromotersAverage */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s);
ret->chromEnd = sqlUnsignedComma(&s);
ret->name = sqlStringComma(&s);
ret->score = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->strand, sizeof(ret->strand));
ret->thickStart = sqlUnsignedComma(&s);
ret->thickEnd = sqlUnsignedComma(&s);
ret->reserved = sqlUnsignedComma(&s);
ret->geneModel = sqlStringComma(&s);
ret->description = sqlStringComma(&s);
ret->normLog2Ratio = sqlFloatComma(&s);
*pS = s;
return ret;
}

void encodeStanfordPromotersAverageFree(struct encodeStanfordPromotersAverage **pEl)
/* Free a single dynamically allocated encodeStanfordPromotersAverage such as created
 * with encodeStanfordPromotersAverageLoad(). */
{
struct encodeStanfordPromotersAverage *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->name);
freeMem(el->geneModel);
freeMem(el->description);
freez(pEl);
}

void encodeStanfordPromotersAverageFreeList(struct encodeStanfordPromotersAverage **pList)
/* Free a list of dynamically allocated encodeStanfordPromotersAverage's */
{
struct encodeStanfordPromotersAverage *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    encodeStanfordPromotersAverageFree(&el);
    }
*pList = NULL;
}

void encodeStanfordPromotersAverageOutput(struct encodeStanfordPromotersAverage *el, FILE *f, char sep, char lastSep) 
/* Print out encodeStanfordPromotersAverage.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->score);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->thickStart);
fputc(sep,f);
fprintf(f, "%u", el->thickEnd);
fputc(sep,f);
fprintf(f, "%u", el->reserved);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->geneModel);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->description);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%g", el->normLog2Ratio);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

