# wgEncodeCell.sql was originally generated by the autoSql program, which also 
# generated wgEncodeCell.c and wgEncodeCell.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Cell types used by ENCODE (2007-2012)
CREATE TABLE wgEncodeCell (
    id int unsigned not null,	# internal id
    term varchar(255) not null,	# public identifier
    description varchar(255) not null,	# descriptive phrase
    tissue varchar(255) not null,	# organ, anatomical site
    type varchar(255) not null,	# tissue, cell line, or differentiated
    cancer varchar(255) not null,	# cancer or normal
    developmental varchar(255) not null,	# cell lineage
    sex varchar(255) not null,	# M, F, or U for unknown
    vendor varchar(255) not null,	# name of vendor or lab provider
    vendorId varchar(255) not null,	# vendor product code or identifier
    url varchar(255) not null,	# order URL or protocol document
    ontoTerm varchar(255) not null,	# ontology term
    btOntoTerm varchar(255) not null,	# ontology term from Brenda Tissue Ontology
    donor varchar(255) not null,	# donor accession at encodeproject.org
              #Indices
    PRIMARY KEY(id)
);
