# exprBed.sql was originally generated by the autoSql program, which also 
# generated exprBed.c and exprBed.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Expression data information
CREATE TABLE exprBed (
    chrom varchar(255) not null,	# Chromosome name
    chromStart int unsigned not null,	# position in nucleotides where feature starts on chromosome
    chromEnd int unsigned not null,	# position in nucleotides where featrure stops on chromsome
    name varchar(255) not null,	# feature standardized name; can be a gene, exon or other
    size int unsigned not null,	# Size of the feature, may be useful if we cannot place it
    uniqueAlign int unsigned not null,	# 1 if alignment was a global maximum, 0 otherwise
    score int unsigned not null,	# Score from pslLayout of best score
    hname varchar(255) not null,	# feature human name: can be a gene, exon or other
    numExp int unsigned not null,	# Number of experiments in this bed
    hybes longblob not null,	# Name of experimental hybridization performed, often name of tissue used
    scores longblob not null,	# log of ratio of feature for particular hybridization
              #Indices
    PRIMARY KEY(chrom)
);
