# gbSeq.sql was originally generated by the autoSql program, which also 
# generated gbSeq.c and gbSeq.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Information about sequences contained in files described in gbExtFile
CREATE TABLE gbSeq (
    id int unsigned not null,	# ID/index
    acc varchar(255) not null,	# Accession of sequence
    version int not null,	# Genbank version
    size int unsigned not null,	# Size of sequence (number of bases)
    gbExtFile int unsigned not null,	# ID/index of file in gbExtFile
    file_offset bigint not null,	# byte offset of sequence in file
    file_size int unsigned not null,	# byte size of sequence in file
    type enum("EST", "mRNA", "PEP")  not null,	# Type of sequence
    srcDb enum("GenBank", "RefSeq", "Other")  not null,	# Source database
              #Indices
    PRIMARY KEY(id)
);
