# genePred.sql was originally generated by the autoSql program, which also 
# generated genePred.c and genePred.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#A gene prediction.
CREATE TABLE genieStat (
    name varchar(255) not null,	# Name of gene
    chrom varchar(255) not null,	# Chromosome name
    strand char(1) not null,	# + or - for strand
    txStart int unsigned not null,	# Transcription start position
    txEnd int unsigned not null,	# Transcription end position
    cdsStart int unsigned not null,	# Coding region start
    cdsEnd int unsigned not null,	# Coding region end
    exonCount int unsigned not null,	# Number of exons
    exonStarts longblob not null,	# Exon start positions
    exonEnds longblob not null,	# Exon end positions
              #Indices
    PRIMARY KEY(name(16)),
    INDEX(chrom(12),txStart),
    INDEX(chrom(12),txEnd)
);

CREATE TABLE genieAlt (
    name varchar(255) not null,	# Name of gene
    chrom varchar(255) not null,	# Chromosome name
    strand char(1) not null,	# + or - for strand
    txStart int unsigned not null,	# Transcription start position
    txEnd int unsigned not null,	# Transcription end position
    cdsStart int unsigned not null,	# Coding region start
    cdsEnd int unsigned not null,	# Coding region end
    exonCount int unsigned not null,	# Number of exons
    exonStarts longblob not null,	# Exon start positions
    exonEnds longblob not null,	# Exon end positions
              #Indices
    PRIMARY KEY(name(16)),
    INDEX(chrom(12),txStart),
    INDEX(chrom(12),txEnd)
);
