# genotype.sql was originally generated by the autoSql program, which also 
# generated genotype.c and genotype.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Genotypes from HapMap data
CREATE TABLE genotype (
    rsId        varchar(255) not null,	#  rs#		# rs10
    SNPalleles  char(3) not null,	#  SNPalleles	# A/C
    chrom       varchar(255) not null,	#  chrom	# Chr7
    chromStart  int not null,		#  pos		# 91995917
    strand      char(1) not null,	#  strand	# +
    assembly    varchar(255) not null,	#  genome_build	# ncbi_b34
    center      varchar(255) not null,	#  center	# illumina
    protLSID    varchar(255) not null,	#  protLSID	# urn:LSID:illumina.hapmap.org:Protocol:Golden_Gate_1.0.0:1
    assayLSID   varchar(255) not null,	#  assayLSID	# urn:LSID:illumina.hapmap.org:Assay:19660:1
    panelLSID   varchar(255) not null,	#  panelLSID	# urn:lsid:dcc.hapmap.org:Panel:CEPH-30-trios:1
    NA06985     char(2) not null,	#  NA06985	# CC
    NA06991     char(2) not null,	#  NA06991	# CC
    NA06993     char(2) not null,	#  NA06993	# CC
    NA06993_dup char(2) not null,	#  NA06993.dup	# CC
    NA06994     char(2) not null,	#  NA06994	# CC
    NA07000     char(2) not null,	#  NA07000	# CC
    NA07019     char(2) not null,	#  NA07019	# CC
    NA07022     char(2) not null,	#  NA07022	# CC
    NA07029     char(2) not null,	#  NA07029	# CC
    NA07034     char(2) not null,	#  NA07034	# CC
    NA07048     char(2) not null,	#  NA07048	# CC
    NA07055     char(2) not null,	#  NA07055	# CC
    NA07056     char(2) not null,	#  NA07056	# CC
    NA07345     char(2) not null,	#  NA07345	# CC
    NA07348     char(2) not null,	#  NA07348	# CC
    NA07357     char(2) not null,	#  NA07357	# CC
    NA10830     char(2) not null,	#  NA10830	# CC
    NA10831     char(2) not null,	#  NA10831	# CC
    NA10835     char(2) not null,	#  NA10835	# CC
    NA10838     char(2) not null,	#  NA10838	# CC
    NA10839     char(2) not null,	#  NA10839	# CC
    NA10846     char(2) not null,	#  NA10846	# CC
    NA10847     char(2) not null,	#  NA10847	# CC
    NA10851     char(2) not null,	#  NA10851	# CC
    NA10854     char(2) not null,	#  NA10854	# CC
    NA10855     char(2) not null,	#  NA10855	# CC
    NA10856     char(2) not null,	#  NA10856	# CC
    NA10857     char(2) not null,	#  NA10857	# CC
    NA10859     char(2) not null,	#  NA10859	# CC
    NA10860     char(2) not null,	#  NA10860	# CC
    NA10861     char(2) not null,	#  NA10861	# CC
    NA10863     char(2) not null,	#  NA10863	# CC
    NA11829     char(2) not null,	#  NA11829	# CC
    NA11830     char(2) not null,	#  NA11830	# CC
    NA11831     char(2) not null,	#  NA11831	# CC
    NA11832     char(2) not null,	#  NA11832	# CC
    NA11839     char(2) not null,	#  NA11839	# CC
    NA11840     char(2) not null,	#  NA11840	# CC
    NA11881     char(2) not null,	#  NA11881	# CC
    NA11882     char(2) not null,	#  NA11882	# CC
    NA11992     char(2) not null,	#  NA11992	# CC
    NA11993     char(2) not null,	#  NA11993	# CC
    NA11993_dup char(2) not null,	#  NA11993.dup	# CC
    NA11994     char(2) not null,	#  NA11994	# AC
    NA11995     char(2) not null,	#  NA11995	# CC
    NA12003     char(2) not null,	#  NA12003	# CC
    NA12003_dup char(2) not null,	#  NA12003.dup	# CC
    NA12004     char(2) not null,	#  NA12004	# CC
    NA12005     char(2) not null,	#  NA12005	# CC
    NA12006     char(2) not null,	#  NA12006	# CC
    NA12043     char(2) not null,	#  NA12043	# CC
    NA12044     char(2) not null,	#  NA12044	# CC
    NA12056     char(2) not null,	#  NA12056	# CC
    NA12057     char(2) not null,	#  NA12057	# CC
    NA12144     char(2) not null,	#  NA12144	# CC
    NA12145     char(2) not null,	#  NA12145	# CC
    NA12146     char(2) not null,	#  NA12146	# CC
    NA12154     char(2) not null,	#  NA12154	# CC
    NA12155     char(2) not null,	#  NA12155	# CC
    NA12156     char(2) not null,	#  NA12156	# CC
    NA12156_dup char(2) not null,	#  NA12156.dup	# CC
    NA12234     char(2) not null,	#  NA12234	# CC
    NA12236     char(2) not null,	#  NA12236	# CC
    NA12239     char(2) not null,	#  NA12239	# CC
    NA12248     char(2) not null,	#  NA12248	# CC
    NA12248_dup char(2) not null,	#  NA12248.dup	# CC
    NA12249     char(2) not null,	#  NA12249	# CC
    NA12264     char(2) not null,	#  NA12264	# CC
    NA12707     char(2) not null,	#  NA12707	# CC
    NA12716     char(2) not null,	#  NA12716	# CC
    NA12717     char(2) not null,	#  NA12717	# CC
    NA12740     char(2) not null,	#  NA12740	# CC
    NA12750     char(2) not null,	#  NA12750	# CC
    NA12751     char(2) not null,	#  NA12751	# CC
    NA12752     char(2) not null,	#  NA12752	# CC
    NA12753     char(2) not null,	#  NA12753	# CC
    NA12760     char(2) not null,	#  NA12760	# AC
    NA12761     char(2) not null,	#  NA12761	# CC
    NA12762     char(2) not null,	#  NA12762	# CC
    NA12763     char(2) not null,	#  NA12763	# CC
    NA12801     char(2) not null,	#  NA12801	# CC
    NA12802     char(2) not null,	#  NA12802	# CC
    NA12812     char(2) not null,	#  NA12812	# AC
    NA12813     char(2) not null,	#  NA12813	# CC
    NA12814     char(2) not null,	#  NA12814	# CC
    NA12815     char(2) not null,	#  NA12815	# CC
    NA12864     char(2) not null,	#  NA12864	# CC
    NA12865     char(2) not null,	#  NA12865	# CC
    NA12872     char(2) not null,	#  NA12872	# CC
    NA12873     char(2) not null,	#  NA12873	# AC
    NA12874     char(2) not null,	#  NA12874	# CC
    NA12875     char(2) not null,	#  NA12875	# CC
    NA12878     char(2) not null,	#  NA12878	# CC
    NA12891     char(2) not null,	#  NA12891	# CC
    NA12892     char(2) not null,	#  NA12892	# CC
              #Indices
    INDEX(rsId)
);
