# hgdpGeo.sql was originally generated by the autoSql program, which also 
# generated hgdpGeo.c and hgdpGeo.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Human Genome Diversity Project population allele frequencies (bed 4+)
CREATE TABLE hgdpGeo (
    bin smallint not null,      # Bin number for browser speedup
    chrom varchar(255) not null,	# Reference sequence chromosome or scaffold
    chromStart int unsigned not null,	# Start position in chromosome
    chromEnd int unsigned not null,	# End position in chromosome
    name varchar(255) not null,	# SNP ID (dbSNP reference SNP rsNNNNN ID)
    ancestralAllele char(1) not null,	# Ancestral allele on forward strand of reference genome assembly
    derivedAllele char(1) not null,	# Derived allele on forward strand of reference genome assembly
    popFreqs longblob not null,	# For each population in alphabetical order, the proportion of the population carrying the ancestral allele.
              #Indices
    INDEX(chrom,bin),
    INDEX(name)
);
