# pgSiftPred.sql was originally generated by the autoSql program, which also 
# generated pgSiftPred.c and pgSiftPred.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#sift predictions for pgSnp tracks
CREATE TABLE pgSiftPred (
    chrom varchar(255) not null,	# Chromosome
    chromStart int unsigned not null,	# Start position in chrom
    chromEnd int unsigned not null,	# End position in chrom
    prediction varchar(255) not null,	# sifts prediction, damaging, tolerated,...
    geneId varchar(255),	# gene ID, Ensembl
    geneName varchar(255),	# gene name
    geneDesc longblob,	# gene description
    protFamDesc longblob,	# protein family description
    omimDisease varchar(255),	# OMIM disease
    aveAlleleFreq varchar(255),	# Average allele frequencies
    ceuAlleleFreq varchar(255),	# Caucasian allele frequencies
              #Indices
    INDEX(chrom(20), chromStart)
);
