# pileups.sql was originally generated by the autoSql program, which also 
# generated pileups.c and pileups.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Pileup locations and hit count min/avg/max.
CREATE TABLE pileups (
    chrom varchar(255) not null,	# Chromosome.
    chromStart int unsigned not null,	# Start position in chromosome
    chromEnd int unsigned not null,	# End position in chromosome
    name varchar(255) not null,	# Name (pileup location suitable for browser position)
    score int unsigned not null,	# Int score (bed compat) -- use average by default.
    pMin int unsigned not null,	# Minimum hit count of any base in this pileup.
    pAvg float not null,	# Average hit count for all bases in this pileup.
    pMax int unsigned not null,	# Maximum hit count of any base in this pileup.
              #Indices
    PRIMARY KEY(chrom(16),chromStart)
);
