# polyGenotype.sql was originally generated by the autoSql program, which also 
# generated polyGenotype.c and polyGenotype.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Genotype Information for Retrotransposon Insertion Polymorphisms (RIP) in Humans
CREATE TABLE polyGenotype (
    name varchar(255) not null,	# Database ID identifying RIP
    ethnicGroup varchar(255) not null,	# Ethnic group for this measurement
    plusPlus int not null,	# homozygous wild type allele count
    plusMinus int not null,	# heterozygous allele count
    minusMinus int not null,	# homozygous allele count
    sampleSize int not null,	# number of measurements
    alleleFrequency float not null,	# frequency of homozygosity
    unbiasedHeterozygosity float not null,	# frequency of heterozygosity
              #Indices
    INDEX(name(20))
);
