# putaInfo.sql was originally generated by the autoSql program, which also 
# generated putaInfo.c and putaInfo.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#store the general info for a putative real or pseudo gene
CREATE TABLE putaInfo (
    chrom varchar(255) not null,	# stamp's chrom
    chromStart int unsigned not null,	# stamp's chrom start
    chromEnd int unsigned not null,	# stamp's chromEnd
    name varchar(255) not null,	# stamp's name
    score int unsigned not null,	# aligned score
    strand varchar(255) not null,	# stamp's strand
    oChrom varchar(255) not null,	# stamper chrom
    oChromStart int unsigned not null,	# stamper chrom start
    oChromEnd int unsigned not null,	# stamper chrom end
    blockCount int unsigned not null,	# total stamper blocks
    stop int unsigned not null,	# 1 .. with stop; 0 .. without stop
    tExons longblob not null,	# stamper (cds) exons
    qExons longblob not null,	# stamp (mapped) (cds) exons
    qBases longblob not null,	# stamp (aligend) (cds) bases
    repeats longblob not null,	# (cds) has repeat inserted
    stops longblob not null,	# stops for each exon
    id longblob not null,	# (cds) aligned Identity
              #Indices
    INDEX(chrom),	
    INDEX(name)
);
