# recombRate.sql was originally generated by the autoSql program, which also 
# generated recombRate.c and recombRate.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Describes the recombination rate in 1Mb intervals based on deCODE map
CREATE TABLE recombRate (
    chrom varchar(255) not null,	# Human chromosome number
    chromStart int unsigned not null,	# Start position in genoSeq
    chromEnd int unsigned not null,	# End position in genoSeq
    name varchar(255) not null,	# Constant string recombRate
    decodeAvg float not null,	# Calculated deCODE recombination rate
    decodeFemale float not null,	# Calculated deCODE female recombination rate
    decodeMale float not null,	# Calculated deCODE male recombination rate
    marshfieldAvg float not null,	# Calculated Marshfield recombination rate
    marshfieldFemale float not null,	# Calculated Marshfield female recombination rate
    marshfieldMale float not null,	# Calculated Marshfield male recombination rate
    genethonAvg float not null,	# Calculated Genethon recombination rate
    genethonFemale float not null,	# Calculated Genethon female recombination rate
    genethonMale float not null,	# Calculated Genethon male recombination rate
              #Indices
    INDEX(chrom(8),chromStart)
);
