/* sangerGeneToWBGeneID.c was originally generated by the autoSql program, which also 
 * generated sangerGeneToWBGeneID.h and sangerGeneToWBGeneID.sql.  This module links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2014 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "sangerGeneToWBGeneID.h"


void sangerGeneToWBGeneIDStaticLoad(char **row, struct sangerGeneToWBGeneID *ret)
/* Load a row from sangerGeneToWBGeneID table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->sangerGene = row[0];
ret->WBGeneID = row[1];
}

struct sangerGeneToWBGeneID *sangerGeneToWBGeneIDLoad(char **row)
/* Load a sangerGeneToWBGeneID from row fetched with select * from sangerGeneToWBGeneID
 * from database.  Dispose of this with sangerGeneToWBGeneIDFree(). */
{
struct sangerGeneToWBGeneID *ret;

AllocVar(ret);
ret->sangerGene = cloneString(row[0]);
ret->WBGeneID = cloneString(row[1]);
return ret;
}

struct sangerGeneToWBGeneID *sangerGeneToWBGeneIDLoadAll(char *fileName) 
/* Load all sangerGeneToWBGeneID from a whitespace-separated file.
 * Dispose of this with sangerGeneToWBGeneIDFreeList(). */
{
struct sangerGeneToWBGeneID *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileRow(lf, row))
    {
    el = sangerGeneToWBGeneIDLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct sangerGeneToWBGeneID *sangerGeneToWBGeneIDLoadAllByChar(char *fileName, char chopper) 
/* Load all sangerGeneToWBGeneID from a chopper separated file.
 * Dispose of this with sangerGeneToWBGeneIDFreeList(). */
{
struct sangerGeneToWBGeneID *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = sangerGeneToWBGeneIDLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct sangerGeneToWBGeneID *sangerGeneToWBGeneIDLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all sangerGeneToWBGeneID from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with sangerGeneToWBGeneIDFreeList(). */
{
struct sangerGeneToWBGeneID *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = sangerGeneToWBGeneIDLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void sangerGeneToWBGeneIDSaveToDb(struct sqlConnection *conn, struct sangerGeneToWBGeneID *el, char *tableName, int updateSize)
/* Save sangerGeneToWBGeneID as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Strings are automatically escaped to allow insertion into the database. */
{
struct dyString *update = newDyString(updateSize);
sqlDyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  el->sangerGene,  el->WBGeneID);
sqlUpdate(conn, update->string);
freeDyString(&update);
}


struct sangerGeneToWBGeneID *sangerGeneToWBGeneIDCommaIn(char **pS, struct sangerGeneToWBGeneID *ret)
/* Create a sangerGeneToWBGeneID out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new sangerGeneToWBGeneID */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->sangerGene = sqlStringComma(&s);
ret->WBGeneID = sqlStringComma(&s);
*pS = s;
return ret;
}

void sangerGeneToWBGeneIDFree(struct sangerGeneToWBGeneID **pEl)
/* Free a single dynamically allocated sangerGeneToWBGeneID such as created
 * with sangerGeneToWBGeneIDLoad(). */
{
struct sangerGeneToWBGeneID *el;

if ((el = *pEl) == NULL) return;
freeMem(el->sangerGene);
freeMem(el->WBGeneID);
freez(pEl);
}

void sangerGeneToWBGeneIDFreeList(struct sangerGeneToWBGeneID **pList)
/* Free a list of dynamically allocated sangerGeneToWBGeneID's */
{
struct sangerGeneToWBGeneID *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    sangerGeneToWBGeneIDFree(&el);
    }
*pList = NULL;
}

void sangerGeneToWBGeneIDOutput(struct sangerGeneToWBGeneID *el, FILE *f, char sep, char lastSep) 
/* Print out sangerGeneToWBGeneID.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->sangerGene);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->WBGeneID);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

