# switchDbTss.sql was originally generated by the autoSql program, which also 
# generated switchDbTss.c and switchDbTss.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Switchgear Genomics TSS DB table
CREATE TABLE switchDbTss (
    bin smallint unsigned not null,  # bin for speed
    chrom varchar(255) not null,	# Reference sequence chromosome or scaffold
    chromStart int unsigned not null,	# Start in Chromosome
    chromEnd int unsigned not null,	# End in Chromosome
    name varchar(255) not null,	# Name
    score int unsigned not null,	# Score
    strand char(1) not null,	# Strand
    confScore double not null,	# Confidence score
    gmName varchar(255) not null,	# Gene model UID/name
    gmChromStart int unsigned not null,	# Gene model chromStart
    gmChromEnd int unsigned not null,	# Gene model chromEnd
    isPseudo tinyint unsigned not null,	# 0 if not a pseudogene TSS, 1 if it is
              #Indices
    INDEX chrom (chrom(8), bin),
    INDEX chromStart (chrom(8), chromStart),
    INDEX name (name)    
);
