# tableStatus.sql was originally generated by the autoSql program, which also 
# generated tableStatus.c and tableStatus.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#This describe the fields of returned by mysql's show table status
CREATE TABLE tableStatus (
    name varchar(255) not null,	# Name of table
    type varchar(255) not null,	# How table stored: MyISAM/INNOdb etc
    rowFormat varchar(255) not null,	# Seems to be mostly Fixed or Dynamic
    rows int unsigned not null,	# The number of rows in table
    aveRowLength int unsigned not null,	# Average length of row in bytes
    dataLength bigint not null,	# Size of data in table
    maxDataLength bigint not null,	# Maximum data length for this table type
    indexLength bigint not null,	# Length of index in bytes
    dataFree bigint not null,	# Usually zero
    autoIncrement varchar(255) not null,	# Current value of autoincrement - rows+1 or NULL
    createTime varchar(255) not null,	# YYYY-MM-DD HH:MM:SS format creation time
    updateTime varchar(255) not null,	# YYYY-MM-DD HH:MM:SS format last update time
    checkTime varchar(255) not null,	# YYYY-MM-DD HH:MM:SS format last check (not query) time
    createOptions varchar(255) not null,	# Seems to be mostly blank
    comment varchar(255) not null,	# Seems mostly to be blank
              #Indices
    PRIMARY KEY(name)
);
