# trackTable.sql was originally generated by the autoSql program, which also 
# generated trackTable.c and trackTable.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#This describes an annotation track.
CREATE TABLE trackTable (
    mapName varchar(255) not null,	# Symbolic ID of Track
    tableName varchar(255) not null,	# Name of table (without any chrN_ if split)
    shortLabel varchar(255) not null,	# Short label displayed on left
    longLabel varchar(255) not null,	# Long label displayed in middle
    visibility tinyint unsigned not null,	# 0=hide, 1=dense, 2=full
    colorR tinyint unsigned not null,	# Color red component 0-255
    colorG tinyint unsigned not null,	# Color green component 0-255
    colorB tinyint unsigned not null,	# Color blue component 0-255
    altColorR tinyint unsigned not null,	# Light color red component 0-255
    altColorG tinyint unsigned not null,	# Light color green component 0-255
    altColorB tinyint unsigned not null,	# Light color blue component 0-255
    useScore tinyint unsigned not null,	# 1 if use score, 0 if not
    isSplit tinyint unsigned not null,	# 1 if table is split across chromosomes
    private tinyint unsigned not null,	# 1 if only want to show it on test site
    hardCoded tinyint unsigned not null,	# 1 if code to interpret it is build in
              #Indices
    PRIMARY KEY(mapName)
);
