# transRegCode.sql was originally generated by the autoSql program, which also 
# generated transRegCode.c and transRegCode.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Transcription factor binding sites from CHIP/CHIP experiments and conservation
CREATE TABLE transRegCode (
    bin smallint not null,
    chrom varchar(255) not null,	# Chromosome binding site is on
    chromStart int unsigned not null,	# Start position in chromosome
    chromEnd int unsigned not null,	# End position in chromosome
    name varchar(255) not null,	# Name of transcription factore
    score int unsigned not null,	# Score from 0 to 1000
    chipEvidence varchar(255) not null,	# Evidence strength from CHIP/CHIP assay
    consSpecies int unsigned not null,	# Number of species conserved in
              #Indices
    INDEX(bin,chrom(8)),
    INDEX(name(8))
);
