/* ucscRetroOrtho.c was originally generated by the autoSql program, which also 
 * generated ucscRetroOrtho.h and ucscRetroOrtho.sql.  This module links the database and
 * the RAM representation of objects. */

/* Copyright (C) 2014 The Regents of the University of California 
 * See README in this or parent directory for licensing information. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "ucscRetroOrtho.h"


void ucscRetroOrthoStaticLoad(char **row, struct ucscRetroOrtho *ret)
/* Load a row from ucscRetroOrtho table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->name = row[0];
ret->db = row[1];
ret->overlap = sqlSigned(row[2]);
}

struct ucscRetroOrtho *ucscRetroOrthoLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all ucscRetroOrtho from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with ucscRetroOrthoFreeList(). */
{
struct ucscRetroOrtho *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = ucscRetroOrthoLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void ucscRetroOrthoSaveToDb(struct sqlConnection *conn, struct ucscRetroOrtho *el, char *tableName, int updateSize)
/* Save ucscRetroOrtho as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Strings are automatically escaped to allow insertion into the database. */
{
struct dyString *update = newDyString(updateSize);
sqlDyStringPrintf(update, "insert into %s values ( '%s','%s',%d)", 
	tableName,  el->name,  el->db,  el->overlap);
sqlUpdate(conn, update->string);
freeDyString(&update);
}


struct ucscRetroOrtho *ucscRetroOrthoLoad(char **row)
/* Load a ucscRetroOrtho from row fetched with select * from ucscRetroOrtho
 * from database.  Dispose of this with ucscRetroOrthoFree(). */
{
struct ucscRetroOrtho *ret;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->db = cloneString(row[1]);
ret->overlap = sqlSigned(row[2]);
return ret;
}

struct ucscRetroOrtho *ucscRetroOrthoLoadAll(char *fileName) 
/* Load all ucscRetroOrtho from a whitespace-separated file.
 * Dispose of this with ucscRetroOrthoFreeList(). */
{
struct ucscRetroOrtho *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileRow(lf, row))
    {
    el = ucscRetroOrthoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct ucscRetroOrtho *ucscRetroOrthoLoadAllByChar(char *fileName, char chopper) 
/* Load all ucscRetroOrtho from a chopper separated file.
 * Dispose of this with ucscRetroOrthoFreeList(). */
{
struct ucscRetroOrtho *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = ucscRetroOrthoLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct ucscRetroOrtho *ucscRetroOrthoCommaIn(char **pS, struct ucscRetroOrtho *ret)
/* Create a ucscRetroOrtho out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new ucscRetroOrtho */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->db = sqlStringComma(&s);
ret->overlap = sqlSignedComma(&s);
*pS = s;
return ret;
}

void ucscRetroOrthoFree(struct ucscRetroOrtho **pEl)
/* Free a single dynamically allocated ucscRetroOrtho such as created
 * with ucscRetroOrthoLoad(). */
{
struct ucscRetroOrtho *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->db);
freez(pEl);
}

void ucscRetroOrthoFreeList(struct ucscRetroOrtho **pList)
/* Free a list of dynamically allocated ucscRetroOrtho's */
{
struct ucscRetroOrtho *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    ucscRetroOrthoFree(&el);
    }
*pList = NULL;
}

void ucscRetroOrthoOutput(struct ucscRetroOrtho *el, FILE *f, char sep, char lastSep) 
/* Print out ucscRetroOrtho.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->db);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->overlap);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

