# wgRna.sql was originally generated by the autoSql program, which also 
# generated wgRna.c and wgRna.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#CD and H/ACA Box snoRNAs and microRNAs from Weber and Griffiths-Jones
CREATE TABLE wgRna (
    bin smallint not null,	# Bin number for browser speedup
    chrom varchar(255) not null,	# chromosome
    chromStart int unsigned not null,	# Start position in chromosome
    chromEnd int unsigned not null,	# End position in chromosome
    name varchar(255) not null,	# Name of item
    score int unsigned not null,	# Score from 0-1000 (bed6 compat.)
    strand char(1) not null,	# + or - (bed6 compat.)
    thickStart int unsigned not null,	# start of thick region
    thickEnd int unsigned not null,	# start of thick region
    type varchar(255) not null,	# RNA type
              #Indices
    KEY(bin),
    KEY(name)
);
