# zdobnovSynt.sql was originally generated by the autoSql program, which also 
# generated zdobnovSynt.c and zdobnovSynt.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Gene homology-based synteny blocks from Evgeny Zdobnov/Peer Bork et al.
CREATE TABLE zdobnovSynt (
    bin smallint not null,      # Index field
    chrom varchar(255) not null,	# chromosome
    chromStart int unsigned not null,	# Start position in chromosome
    chromEnd int unsigned not null,	# End position in chromosome
    name varchar(255) not null,	# Name of item: 
    score int unsigned not null,	# Score placeholder
    strand char(1) not null,	# placeholder
    thickStart int unsigned not null,	# Start of where display should be thick (start codon)
    thickEnd int unsigned not null,	# End of where display should be thick (stop codon)
    reserved int unsigned not null,	# Always zero for now
    blockCount int not null,	# Number of blocks (syntenic genes)
    blockSizes longblob not null,	# Comma separated list of block sizes
    chromStarts longblob not null,	# Start positions relative to chromStart
    geneNames longblob not null,	# Names of genes (from other species)
              #Indices
    INDEX(chrom(8),bin),
    INDEX(name(12))
);
