# jobResult.sql was originally generated by the autoSql program, which also 
# generated jobResult.c and jobResult.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Info about the result of one job from parasol
CREATE TABLE jobResult (
    status int not null,	# Job status - wait() return format. 0 is good.
    host varchar(255) not null,	# Machine job ran on.
    jobId varchar(255) not null,	# Job queuing system job ID
    exe varchar(255) not null,	# Job executable file (no path)
    usrTicks int not null,	# 'User' CPU time in ticks.
    sysTicks int not null,	# 'System' CPU time in ticks.
    submitTime int unsigned not null,	# Job submission time in seconds since 1/1/1970
    startTime int unsigned not null,	# Job start time in seconds since 1/1/1970
    endTime int unsigned not null,	# Job end time in seconds since 1/1/1970
    user varchar(255) not null,	# User who ran job
    errFile varchar(255) not null,	# Location of stderr file on host
              #Indices
    PRIMARY KEY(status)
);
